//webpack.base.js
const path = require('path')
const webpack = require('webpack')
const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin
const { VueLoaderPlugin } = require('vue-loader')

function resolve(dir) {
  const basePath = path.resolve(__dirname, '../')
  return path.join(basePath, dir)
}

module.exports = {
  mode:'none',
  output: {
    path: path.join(__dirname,"/dist"),
    filename: 'my-lib.js',
    libraryTarget: 'umd',  //用到的模块定义规范
    library: 'myLib',   //库的名字
    libraryExport: 'default'
  },
  module: {
    rules: [
      {
        test: /\.vue$/,
        use:  ['vue-loader']
      },
      {
        test: /\.css$/,
        use:  ['style-loader','css-loader','postcss-loader']
      },
      {
        test: /\.s[ac]ss$/i,
        use:  ['style-loader','css-loader','postcss-loader','sass-loader']
      },
      {
        test: /\.js$/,
        loader: 'babel-loader',
        exclude: /node_modules/,
      }
    ]
  },
  plugins: [
    new VueLoaderPlugin()
  ],
  resolve: {
    alias: {
      '@': resolve('src'),
    }
  }
}

if (process.env.npm_config_report) {
  module.exports.plugins = (module.exports.plugins || []).concat([new BundleAnalyzerPlugin()])
}
