/**
 * JS颜色十六进制转换为rgb或rgba,返回的格式为 rgba（255，255，255，0.5）字符串
 * sHex为传入的十六进制的色值
 * alpha为rgba的透明度
 */
export function colorRgba(sHex, alpha) {
// 十六进制颜色值的正则表达式
    let reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/
    /* 16进制颜色转为RGB格式 */
    let sColor = sHex.toLowerCase()
    if (sColor && reg.test(sColor)) {
        if (sColor.length === 4) {
            let sColorNew = '#'
            for (let i = 1; i < 4; i += 1) {
                sColorNew += sColor.slice(i, i + 1).concat(sColor.slice(i, i + 1))
            }
            sColor = sColorNew
        }
        // 处理六位的颜色值
        let sColorChange = []
        for (let i = 1; i < 7; i += 2) {
            sColorChange.push(parseInt('0x' + sColor.slice(i, i + 2)))
        }
        // return sColorChange.join(',')
        return 'rgba(' + sColorChange.join(',') + ',' + alpha + ')'
    }
    else {
        return sColor
    }
}

//rgb=>rgba
export function rgbToRgba(color, alp) {
    let rgbaAttr = color.match(/[\d.]+/g);
    if (rgbaAttr.length >= 3) {
        let r, g, b;
        r = rgbaAttr[0];
        g = rgbaAttr[1];
        b = rgbaAttr[2];
        return 'rgba(' + r + ',' + g + ',' + b + ',' + alp + ')';
    }
}
//rgba=>rgb
export function rgbaToRgb(color) {
    let rgbaAttr = color.match(/[\d.]+/g);
    if (rgbaAttr.length >= 3) {
        let r, g, b;
        r = rgbaAttr[0];
        g = rgbaAttr[1];
        b = rgbaAttr[2];
        return 'rgb(' + r + ',' + g + ',' + b + ')';
    }
    return '';
}

//获取透明度
export function getRgbaAlp(color) {
    let alp = 1;
    let rgbaReg = /rgba\([\d ]+(?:,([\d. ]+)){3}\)/;
    if (rgbaReg.test(color)) {
        alp = color.replace(rgbaReg, '$1');
    }
    return alp;
}