var local = function () {
  // 本地存储前缀，减少命名冲突
  var prefix = 'ydb';
  return {
      setPrefix: function (_prefix) {
          prefix = _prefix;
          // 本地存储前缀只允许修改一次，如果多次修改，由于单例，可能会导致只能写入，不能读取
          this.setPrefix = null;
      },
      getPrefix: function () {
          return prefix;
      },
      set: function (key, value, expriess = 0) {
          var o = {
              value,
              createTime: Date.now(),
              expriess
          };
          localStorage.setItem(prefix + '-' + key, JSON.stringify(o));
      },
      get: function (key) {
          var storage = JSON.parse(localStorage.getItem(prefix + '-' + key));
          if (!!storage === false) {
              return null;
          }
          else {
              if (storage.expriess <= 0) {
                  return storage.value;
              }
              else {
                  if (storage.expriess + storage.createTime > Date.now()) {
                      return storage.value;
                  }
                  // 过期销毁
                  this.remove(key);
                  return null;
              }
          }
      },
      remove(key) {
          localStorage.removeItem(prefix + '-' + key);
      },
      clear() {
          for (var key in localStorage) {
              if (key.includes(prefix)) {
                  this.remove(key.split('-')[1]);
              }
          }
      }
  }
}



export default local();