import axios from 'axios';
import vm from '../main'
import router from '@/router/index'

const request = createAxiosInstance()
let interfaceArr = []
const clearInterface = (resUrl) => {
  let idex = interfaceArr.findIndex( u => u === resUrl);
  if (idex !== -1) {
    interfaceArr.splice(idex, 1)
  }
}
function createAxiosInstance () {
  const instance = axios.create({
    baseURL: "./",
    timeout: 30000,
    responseType: "json",
  })
  instance.interceptors.request.use((config) => {
    const url = config.url
    let point = url.substring(0, 1);
    if (url.lastIndexOf(".geojson") == -1 && point != '.') {
      config.url = '.' + config.url
    }
    interfaceArr.push(config.url)
    vm.$root.globalLoading = true;
    return config;
  })
  // 添加响应拦截器(对响应数据做点什么)
  instance.interceptors.response.use((response) => {
      setTimeout( ()=> {
        clearInterface(response.config.url);
        if (interfaceArr.length === 0) {
          vm.$root.globalLoading = false;
        }
      }, 300)
      //对自定义code码进行判断,将成功的数据返回出去
      const validateStatus = /^(2|3)\d{2}$/ //code为2或3开头的视作请求成功
      if (validateStatus.test(response.data.status)) {
        return response.data
      }
        return response.data
      },
      (error) => {
        setTimeout( ()=> {
          clearInterface(error.config.url);
          if (interfaceArr.length === 0) {
            vm.$root.globalLoading = false;
          }
        }, 300)
        if (error.response.status === 401) {
          router.push({
            path: '/loginView'
          }).catch(() => {
            
          })
        }
        return error// 将错误继续返回给到具体页面
      }
    )
  
  return instance
}

export default request;
